Subject: [Moq] Re: Knowing the start of a Subgroup
From: Luke Curley <[email-masked]>
To: Suhas Nandakumar <[email-masked]>
Cc: "Mo Zanaty (mzanaty)" <mzanaty=[email-masked]>, Ian Swett <ianswett=[email-masked]>, Cullen Fluffy Jennings <[email-masked]>, Magnus Westerlund <[email-masked]>, MOQ Mailing List <[email-masked]>
Date: Mon, 4 May 2026 13:00:59 -0700
List-Id: Media over QUIC <moq.ietf.org>

What are the use-cases for a sub-group per object/datagram?

I think for media, it would be sending each b-frame as a separate
sub-group. What would be the ideal prioritization there?

On Mon, May 4, 2026, 10:41 AM Suhas Nandakumar <[email-masked]> wrote:

> I think the question comes down to is there a use-case where we need more
> than 256 subgroups and needs to be considered for prioritization. I can't
> think of one, but love to hear from others.
>
> On Mon, May 4, 2026 at 10:36 AM Mo Zanaty (mzanaty) <mzanaty=
> [email-masked]> wrote:
>
>> If an app has no need for Subgroup ID semantic meaning, it can send an
>> unlimited number of objects as separate streams using the same ID (e.g. 0)
>> and reset-at. This seems really ugly, so I’d be willing to have a special
>> header type for single-object stream if that is a strong use case. I agree
>> with the comments in I#1405 that this may be closer to datagram than stream
>> conceptually, which may motivate a specific header type that merges the
>> desired properties of datagram and stream.
>>
>> If the stream-per-object case can be achieved without many subgroup IDs,
>> then maybe a single byte is acceptable.
>>
>> Thanks,
>> Mo
>>
>>
>> ------------------------------
>> *From:* Ian Swett <ianswett=[email-masked]>
>> *Sent:* Monday, May 4, 2026 12:56:05 PM
>> *To:* Mo Zanaty (mzanaty) <[email-masked]>
>> *Cc:* Cullen Fluffy Jennings <[email-masked]>; Magnus Westerlund <
>> [email-masked]>; MOQ Mailing List <[email-masked]>
>> *Subject:* Re: [Moq] Re: Knowing the start of a Subgroup
>>
>> I believe the concern with making Subgroup ID a single byte is if you
>> wanted to do Object-per-Subgroup and couldn't or didn't want to use
>> datagrams, you'd be limited to 256 Objects per Group.
>>
>> Otherwise, making Subgroup ID a byte a very appealing change.  Thinking
>> along those lines is what caused me to file #1405
>> <https://github.com/moq-wg/moq-transport/issues/1405> (Single Object
>> Subgroups don't need a Subgroup ID)
>>
>> Ian
>>
>>
>> On Mon, May 4, 2026 at 12:24 AM Mo Zanaty (mzanaty) <mzanaty=
>> [email-masked]> wrote:
>>
>> Perhaps we should limit Subgroup ID to a single byte. We made everything
>> a varint by default for no good reason. Perhaps we should revisit all
>> varint fields to rationalize if they truly need to be.
>>
>> Thanks,
>> Mo
>>
>>
>> ------------------------------
>> *From:* Ian Swett <ianswett=[email-masked]>
>> *Sent:* Sunday, May 3, 2026 10:38:30 PM
>> *To:* Cullen Fluffy Jennings <[email-masked]>
>> *Cc:* Magnus Westerlund <magnus.westerlund=[email-masked]>;
>> MOQ Mailing List <[email-masked]>
>> *Subject:* [Moq] Re: Knowing the start of a Subgroup
>>
>> Thanks for all the responses, particularly Mo's detailed response.
>>
>> I think we should move forward with the bitfield approach in #1618.
>>
>> I don't love that both Subgroup ID and Priority are ways of prioritizing
>> Objects within a Group.  At some point we agreed that priority should only
>> be a single byte. However, with Subgroup ID as well as priority, we now
>> have a huge space.  In practice, it probably doesn't matter, and I'm just
>> overthinking this.  But it seems like there should be a way to
>> simplify this part of the Object model without restricting any real-world
>> usecases.
>>
>> Thanks, Ian
>>
>> On Fri, May 1, 2026 at 6:14 PM Cullen Fluffy Jennings <[email-masked]>
>> wrote:
>>
>>
>>
>> > On Apr 30, 2026, at 9:08 AM, Ian Swett <[email-masked]> wrote:
>> >
>> >
>> > If we go with the bitflag approach (#1618), are people ok with
>> requiring it be set on the first Object in the Subgroup?  Requiring it
>> gives the feature a lot more value IMO.
>>
>>
>> Yes, that makes sense to me.
>>
>> --
>> Moq mailing list -- [email-masked]
>> To unsubscribe send an email to [email-masked]
>>
> --
> Moq mailing list -- [email-masked]
> To unsubscribe send an email to [email-masked]
>